
grunt = null

module.exports = ->
	grunt = arguments[0]
	grunt.option "stack", true
	require("load-grunt-tasks") grunt
	grunt.initConfig config
	grunt.registerTask name, subtasks for name, subtasks of tasks
	return

#
# Umbrella Tasks
#

tasks = {}

tasks.default = ["rebuild", "test"]

tasks.test = ["shell:test"]

tasks.ship = ["webpack:ship"]

tasks.rebuild = ->
	grunt.task
		.run("clean:js", "coffee:src")
		.then "Build testing entry points for Webpack", ->
			entryPoints = getEntryPoints "js/**/__tests__/*.js"
			grunt.config.set "webpack.test.entry", entryPoints
			grunt.task.run "webpack:test"

#
# Static Configuration
#

config =

	webpack:
		options:
			resolve:
				extensions: ["", ".js"]
			output:
				filename: "[name].js"
			module:
				noParse: [/\.js\.map$/]
				preLoaders: [{ test: /\.js$/, loader: "source-map" }]
		test:
			debug: true
			devtool: "#source-map"
			output:
				path: "tests"
		ship: 
			entry: "./js/index.js"
			output:
				path: "bin"

	coffee:
		options:
			sourceMap: true
			bare: true
		src:
			expand: true
			cwd: "coffee"
			src: ["**/*.coffee"]
			dest: "js"
			ext: ".js"

	shell:
		test: 
			command: "karma start Karmafile.coffee"

	watch:
		test:
			files: ["coffee/**/*.coffee"]
			tasks: ["rebuild"]

	clean:
		js: ["js", "tests"]

#
# Helpers
#

Path = require "path"
Glob = require "globby"

getEntryPoints = (glob) ->
	entryPoints = {}
	for path in Glob.sync glob
		key = Path.join Path.dirname(path), Path.basename(path, Path.extname path)
		entryPoints[key] = "./" + path
	return entryPoints
